/*
        DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
                    Version 2, December 2004

 Copyright (C) 2004 Sam Hocevar <sam@hocevar.net>

 Everyone is permitted to copy and distribute verbatim or modified
 copies of this license document, and changing it is allowed as long
 as the name is changed.

            DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION

  0. You just DO WHAT THE FUCK YOU WANT TO.

*/


#ifndef _ENDIAN_H
#define _ENDIAN_H

#define __LITTLE_ENDIAN 1234
#define __BIG_ENDIAN    4321

#include <sys/isa_defs.h>

#undef __BYTE_ORDER
#if defined( _LITTLE_ENDIAN )
#define __BYTE_ORDER __LITTLE_ENDIAN
#elif defined( _BIG_ENDIAN )
#define __BYTE_ORDER __BIG_ENDIAN
#endif

#undef LITTLE_ENDIAN
#define LITTLE_ENDIAN  __LITTLE_ENDIAN

#undef BIG_ENDIAN
#define BIG_ENDIAN     __BIG_ENDIAN

#undef BYTE_ORDER
#define BYTE_ORDER     __BYTE_ORDER

#ifdef _BSD_SOURCE
# ifndef __EXTENSIONS__
#   define __EXTENSIONS__ 1
# endif
# include <sys/byteorder.h>

# if __BYTE_ORDER == __LITTLE_ENDIAN
#  define htobe16(x) htons (x)
#  define htole16(x) (x)
#  define be16toh(x) ntohs (x)
#  define le16toh(x) (x)

#  define htobe32(x) htonl (x)
#  define htole32(x) (x)
#  define be32toh(x) ntohl (x)
#  define le32toh(x) (x)

#  define htobe64(x) htonll (x)
#  define htole64(x) (x)
#  define be64toh(x) ntohll (x)
#  define le64toh(x) (x)

# else

#  define htobe16(x) (x)
#  define htole16(x) htons (x)
#  define be16toh(x) (x)
#  define le16toh(x) ntohs (x)

#  define htobe32(x) (x)
#  define htole32(x) htonl (x)
#  define be32toh(x) (x)
#  define le32toh(x) ntohl (x)

#  define htobe64(x) (x)
#  define htole64(x) htonll (x)
#  define be64toh(x) (x)
#  define le64toh(x) ntohll (x)
# endif

#endif /* _BSD_SOURCE */

#endif /* _ENDIAN_H */

